#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 144
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 89
#define ALIAS_COUNT 0
#define TOKEN_COUNT 60
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 10
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 10

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_rule = 2,
  anon_sym_LBRACE = 3,
  anon_sym_RBRACE = 4,
  anon_sym_condition = 5,
  anon_sym_events = 6,
  anon_sym_match = 7,
  anon_sym_meta = 8,
  anon_sym_options = 9,
  anon_sym_outcome = 10,
  anon_sym_COLON = 11,
  anon_sym_EQ = 12,
  anon_sym_all = 13,
  anon_sym_any = 14,
  anon_sym_not = 15,
  anon_sym_STAR = 16,
  anon_sym_SLASH = 17,
  anon_sym_PLUS = 18,
  anon_sym_DASH = 19,
  anon_sym_BANG_EQ = 20,
  anon_sym_LT = 21,
  anon_sym_LT_EQ = 22,
  anon_sym_GT = 23,
  anon_sym_GT_EQ = 24,
  anon_sym_and = 25,
  anon_sym_or = 26,
  anon_sym_in = 27,
  anon_sym_regex = 28,
  anon_sym_cidr = 29,
  anon_sym_PERCENT = 30,
  anon_sym_COMMA = 31,
  anon_sym_over = 32,
  anon_sym_before = 33,
  anon_sym_after = 34,
  anon_sym_LBRACK = 35,
  anon_sym_RBRACK = 36,
  anon_sym_LPAREN = 37,
  anon_sym_RPAREN = 38,
  anon_sym_DOLLAR = 39,
  sym_raw_string_literal = 40,
  anon_sym_DQUOTE = 41,
  anon_sym_DQUOTE2 = 42,
  sym__interpreted_string_literal_basic_content = 43,
  sym_escape_sequence = 44,
  sym_integer_literal = 45,
  sym_float_literal = 46,
  anon_sym_m = 47,
  anon_sym_h = 48,
  anon_sym_d = 49,
  sym_regex_literal = 50,
  anon_sym_true = 51,
  anon_sym_false = 52,
  sym_null = 53,
  sym_attribute_identifier = 54,
  sym_nocase = 55,
  anon_sym_DOT = 56,
  sym_comment = 57,
  sym__whitespace = 58,
  sym_not_operator = 59,
  sym_source_file = 60,
  sym_rule_definition = 61,
  sym_section_key = 62,
  sym_section = 63,
  aux_sym__statements = 64,
  sym_assignment_statement = 65,
  sym_declaration_statement = 66,
  sym_expression_statement = 67,
  sym_match_statement = 68,
  sym__expression = 69,
  sym_unary_expression = 70,
  sym_binary_expression = 71,
  sym_call_expression = 72,
  sym_reference_list_expression = 73,
  sym_match_expression = 74,
  sym_index_expression = 75,
  sym_parenthesized_expression = 76,
  sym_variable_identifier = 77,
  sym__string_literal = 78,
  sym_interpreted_string_literal = 79,
  sym_duration_literal = 80,
  sym_boolean_literal = 81,
  sym_function_expression = 82,
  sym_argument_list = 83,
  aux_sym_source_file_repeat1 = 84,
  aux_sym_rule_definition_repeat1 = 85,
  aux_sym_match_expression_repeat1 = 86,
  aux_sym_interpreted_string_literal_repeat1 = 87,
  aux_sym_argument_list_repeat1 = 88,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_rule] = "rule",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_condition] = "condition",
  [anon_sym_events] = "events",
  [anon_sym_match] = "match",
  [anon_sym_meta] = "meta",
  [anon_sym_options] = "options",
  [anon_sym_outcome] = "outcome",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_all] = "all",
  [anon_sym_any] = "any",
  [anon_sym_not] = "not",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_in] = "in",
  [anon_sym_regex] = "regex",
  [anon_sym_cidr] = "cidr",
  [anon_sym_PERCENT] = "%",
  [anon_sym_COMMA] = ",",
  [anon_sym_over] = "over",
  [anon_sym_before] = "before",
  [anon_sym_after] = "after",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOLLAR] = "$",
  [sym_raw_string_literal] = "raw_string_literal",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE2] = "\"",
  [sym__interpreted_string_literal_basic_content] = "_interpreted_string_literal_basic_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_integer_literal] = "integer_literal",
  [sym_float_literal] = "float_literal",
  [anon_sym_m] = "m",
  [anon_sym_h] = "h",
  [anon_sym_d] = "d",
  [sym_regex_literal] = "regex_literal",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_null] = "null",
  [sym_attribute_identifier] = "attribute_identifier",
  [sym_nocase] = "nocase",
  [anon_sym_DOT] = ".",
  [sym_comment] = "comment",
  [sym__whitespace] = "_whitespace",
  [sym_not_operator] = "not_operator",
  [sym_source_file] = "source_file",
  [sym_rule_definition] = "rule_definition",
  [sym_section_key] = "section_key",
  [sym_section] = "section",
  [aux_sym__statements] = "_statements",
  [sym_assignment_statement] = "assignment_statement",
  [sym_declaration_statement] = "declaration_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_match_statement] = "match_statement",
  [sym__expression] = "_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_call_expression] = "call_expression",
  [sym_reference_list_expression] = "reference_list_expression",
  [sym_match_expression] = "match_expression",
  [sym_index_expression] = "index_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_variable_identifier] = "variable_identifier",
  [sym__string_literal] = "_string_literal",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [sym_duration_literal] = "duration_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_function_expression] = "function_expression",
  [sym_argument_list] = "argument_list",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_rule_definition_repeat1] = "rule_definition_repeat1",
  [aux_sym_match_expression_repeat1] = "match_expression_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_rule] = anon_sym_rule,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_condition] = anon_sym_condition,
  [anon_sym_events] = anon_sym_events,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_meta] = anon_sym_meta,
  [anon_sym_options] = anon_sym_options,
  [anon_sym_outcome] = anon_sym_outcome,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_all] = anon_sym_all,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_regex] = anon_sym_regex,
  [anon_sym_cidr] = anon_sym_cidr,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_over] = anon_sym_over,
  [anon_sym_before] = anon_sym_before,
  [anon_sym_after] = anon_sym_after,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym__interpreted_string_literal_basic_content] = sym__interpreted_string_literal_basic_content,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_integer_literal] = sym_integer_literal,
  [sym_float_literal] = sym_float_literal,
  [anon_sym_m] = anon_sym_m,
  [anon_sym_h] = anon_sym_h,
  [anon_sym_d] = anon_sym_d,
  [sym_regex_literal] = sym_regex_literal,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_null] = sym_null,
  [sym_attribute_identifier] = sym_attribute_identifier,
  [sym_nocase] = sym_nocase,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_comment] = sym_comment,
  [sym__whitespace] = sym__whitespace,
  [sym_not_operator] = sym_not_operator,
  [sym_source_file] = sym_source_file,
  [sym_rule_definition] = sym_rule_definition,
  [sym_section_key] = sym_section_key,
  [sym_section] = sym_section,
  [aux_sym__statements] = aux_sym__statements,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_declaration_statement] = sym_declaration_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_match_statement] = sym_match_statement,
  [sym__expression] = sym__expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_reference_list_expression] = sym_reference_list_expression,
  [sym_match_expression] = sym_match_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_variable_identifier] = sym_variable_identifier,
  [sym__string_literal] = sym__string_literal,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [sym_duration_literal] = sym_duration_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_function_expression] = sym_function_expression,
  [sym_argument_list] = sym_argument_list,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_rule_definition_repeat1] = aux_sym_rule_definition_repeat1,
  [aux_sym_match_expression_repeat1] = aux_sym_match_expression_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_rule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_condition] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_events] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_options] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_outcome] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_all] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_regex] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cidr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_over] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_before] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_after] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__interpreted_string_literal_basic_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_m] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_h] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_d] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_nocase] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_section_key] = {
    .visible = true,
    .named = true,
  },
  [sym_section] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements] = {
    .visible = false,
    .named = false,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_list_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_duration_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rule_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_arguments = 1,
  field_attribute = 2,
  field_field = 3,
  field_function = 4,
  field_index = 5,
  field_left = 6,
  field_name = 7,
  field_operand = 8,
  field_operator = 9,
  field_right = 10,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_left] = "left",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_right] = "right",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 1},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 9, .length = 3},
  [8] = {.index = 12, .length = 3},
  [9] = {.index = 15, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_operand, 0},
  [2] =
    {field_operand, 1},
    {field_operator, 0},
  [4] =
    {field_arguments, 1},
    {field_function, 0},
  [6] =
    {field_attribute, 2},
  [7] =
    {field_left, 0},
    {field_right, 2},
  [9] =
    {field_field, 1},
    {field_field, 2},
    {field_operand, 0},
  [12] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [15] =
    {field_index, 2},
    {field_operand, 0},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 29,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 33,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 31,
  [40] = 32,
  [41] = 41,
  [42] = 38,
  [43] = 37,
  [44] = 36,
  [45] = 45,
  [46] = 46,
  [47] = 45,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 4,
  [62] = 7,
  [63] = 9,
  [64] = 64,
  [65] = 64,
  [66] = 16,
  [67] = 27,
  [68] = 17,
  [69] = 10,
  [70] = 22,
  [71] = 11,
  [72] = 14,
  [73] = 24,
  [74] = 28,
  [75] = 26,
  [76] = 25,
  [77] = 77,
  [78] = 21,
  [79] = 19,
  [80] = 18,
  [81] = 13,
  [82] = 12,
  [83] = 15,
  [84] = 84,
  [85] = 84,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 90,
  [92] = 92,
  [93] = 93,
  [94] = 92,
  [95] = 95,
  [96] = 96,
  [97] = 95,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 99,
  [103] = 103,
  [104] = 103,
  [105] = 105,
  [106] = 106,
  [107] = 105,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 112,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 122,
  [131] = 131,
  [132] = 121,
  [133] = 133,
  [134] = 123,
  [135] = 131,
  [136] = 127,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 138,
  [142] = 126,
  [143] = 139,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '\n', 74,
        '!', 55,
        '"', 48,
        '$', 59,
        '%', 59,
        '(', 59,
        ')', 59,
        '*', 59,
        '+', 59,
        ',', 59,
        '-', 59,
        '.', 57,
        '/', 50,
        ':', 59,
        '<', 55,
        '=', 59,
        '>', 55,
        '[', 59,
        '\\', 10,
        ']', 59,
        '`', 56,
        '{', 59,
        '}', 59,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(53);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(74);
      if (lookahead == '"') ADVANCE(48);
      if (lookahead == '/') ADVANCE(49);
      if (lookahead == '\\') ADVANCE(10);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(59);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 2:
      if (lookahead == '\r') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0) ADVANCE(72);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 9,
        '"', 47,
        ')', 44,
        '*', 29,
        '+', 32,
        ',', 40,
        '-', 33,
        '.', 21,
        '/', 30,
        '<', 35,
        '=', 28,
        '>', 37,
        '[', 41,
        '`', 11,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(67);
      END_STATE();
    case 4:
      if (lookahead == '(') ADVANCE(43);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '=') ADVANCE(28);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(74);
      END_STATE();
    case 5:
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(72);
      END_STATE();
    case 6:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(70);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == '\\') ADVANCE(22);
      if (lookahead != 0) ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '=') ADVANCE(34);
      END_STATE();
    case 10:
      if (lookahead == 'U') ADVANCE(20);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'x') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      if (lookahead != 0) ADVANCE(60);
      END_STATE();
    case 11:
      if (lookahead == '`') ADVANCE(46);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 22:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 23:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '!', 9,
        '"', 47,
        '$', 45,
        '%', 39,
        '(', 43,
        ')', 44,
        '*', 29,
        '+', 32,
        ',', 40,
        '-', 33,
        '.', 12,
        '/', 31,
        ':', 27,
        '<', 35,
        '=', 28,
        '>', 37,
        '[', 41,
        ']', 42,
        '`', 11,
        '{', 25,
        '}', 26,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(67);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(72);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(8);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(59);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(54);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(51);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '.') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(59);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '=') ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(59);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '`') ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(56);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '.') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_integer_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_float_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_regex_literal);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_attribute_identifier);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0) ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead != 0) ADVANCE(72);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym__whitespace);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'h', 7,
        'i', 8,
        'm', 9,
        'n', 10,
        'o', 11,
        'r', 12,
        't', 13,
      );
      END_STATE();
    case 1:
      if (lookahead == 'f') ADVANCE(14);
      if (lookahead == 'l') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(17);
      END_STATE();
    case 3:
      if (lookahead == 'i') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_d);
      END_STATE();
    case 5:
      if (lookahead == 'v') ADVANCE(20);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(21);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_h);
      END_STATE();
    case 8:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_m);
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'u') ADVANCE(26);
      END_STATE();
    case 11:
      if (lookahead == 'p') ADVANCE(27);
      if (lookahead == 'r') ADVANCE(28);
      if (lookahead == 'u') ADVANCE(29);
      if (lookahead == 'v') ADVANCE(30);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 14:
      if (lookahead == 't') ADVANCE(34);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(35);
      END_STATE();
    case 16:
      if (lookahead == 'd') ADVANCE(36);
      if (lookahead == 'y') ADVANCE(37);
      END_STATE();
    case 17:
      if (lookahead == 'f') ADVANCE(38);
      END_STATE();
    case 18:
      if (lookahead == 'd') ADVANCE(39);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 25:
      if (lookahead == 'c') ADVANCE(45);
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(47);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(49);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 31:
      if (lookahead == 'g') ADVANCE(51);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(52);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 34:
      if (lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_all);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(56);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(57);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 43:
      if (lookahead == 'c') ADVANCE(60);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(65);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(68);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_cidr);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 60:
      if (lookahead == 'h') ADVANCE(75);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_over);
      END_STATE();
    case 67:
      if (lookahead == 'x') ADVANCE(79);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_rule);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_after);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 73:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(85);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_regex);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_before);
      END_STATE();
    case 81:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_events);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_nocase);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_options);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_outcome);
      END_STATE();
    case 89:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_condition);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 23},
  [2] = {.lex_state = 23},
  [3] = {.lex_state = 23},
  [4] = {.lex_state = 23},
  [5] = {.lex_state = 23},
  [6] = {.lex_state = 23},
  [7] = {.lex_state = 23},
  [8] = {.lex_state = 23},
  [9] = {.lex_state = 23},
  [10] = {.lex_state = 23},
  [11] = {.lex_state = 23},
  [12] = {.lex_state = 23},
  [13] = {.lex_state = 23},
  [14] = {.lex_state = 23},
  [15] = {.lex_state = 23},
  [16] = {.lex_state = 23},
  [17] = {.lex_state = 23},
  [18] = {.lex_state = 23},
  [19] = {.lex_state = 23},
  [20] = {.lex_state = 23},
  [21] = {.lex_state = 23},
  [22] = {.lex_state = 23},
  [23] = {.lex_state = 23},
  [24] = {.lex_state = 23},
  [25] = {.lex_state = 23},
  [26] = {.lex_state = 23},
  [27] = {.lex_state = 23},
  [28] = {.lex_state = 23},
  [29] = {.lex_state = 23},
  [30] = {.lex_state = 23},
  [31] = {.lex_state = 23},
  [32] = {.lex_state = 23},
  [33] = {.lex_state = 23},
  [34] = {.lex_state = 23},
  [35] = {.lex_state = 23},
  [36] = {.lex_state = 23},
  [37] = {.lex_state = 23},
  [38] = {.lex_state = 23},
  [39] = {.lex_state = 23},
  [40] = {.lex_state = 23},
  [41] = {.lex_state = 23},
  [42] = {.lex_state = 23},
  [43] = {.lex_state = 23},
  [44] = {.lex_state = 23},
  [45] = {.lex_state = 23},
  [46] = {.lex_state = 23},
  [47] = {.lex_state = 23},
  [48] = {.lex_state = 23},
  [49] = {.lex_state = 23},
  [50] = {.lex_state = 23},
  [51] = {.lex_state = 23},
  [52] = {.lex_state = 23},
  [53] = {.lex_state = 23},
  [54] = {.lex_state = 23},
  [55] = {.lex_state = 23},
  [56] = {.lex_state = 23},
  [57] = {.lex_state = 23},
  [58] = {.lex_state = 23},
  [59] = {.lex_state = 23},
  [60] = {.lex_state = 23},
  [61] = {.lex_state = 3},
  [62] = {.lex_state = 3},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 3},
  [65] = {.lex_state = 3},
  [66] = {.lex_state = 3},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 3},
  [72] = {.lex_state = 3},
  [73] = {.lex_state = 3},
  [74] = {.lex_state = 3},
  [75] = {.lex_state = 3},
  [76] = {.lex_state = 3},
  [77] = {.lex_state = 3},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 3},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 3},
  [82] = {.lex_state = 3},
  [83] = {.lex_state = 3},
  [84] = {.lex_state = 3},
  [85] = {.lex_state = 3},
  [86] = {.lex_state = 23},
  [87] = {.lex_state = 23},
  [88] = {.lex_state = 23},
  [89] = {.lex_state = 23},
  [90] = {.lex_state = 3},
  [91] = {.lex_state = 3},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 23},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 1},
  [96] = {.lex_state = 1},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 23},
  [99] = {.lex_state = 23},
  [100] = {.lex_state = 23},
  [101] = {.lex_state = 23},
  [102] = {.lex_state = 23},
  [103] = {.lex_state = 23},
  [104] = {.lex_state = 23},
  [105] = {.lex_state = 23},
  [106] = {.lex_state = 4},
  [107] = {.lex_state = 23},
  [108] = {.lex_state = 23},
  [109] = {.lex_state = 3},
  [110] = {.lex_state = 3},
  [111] = {.lex_state = 4},
  [112] = {.lex_state = 23},
  [113] = {.lex_state = 23},
  [114] = {.lex_state = 23},
  [115] = {.lex_state = 23},
  [116] = {.lex_state = 23},
  [117] = {.lex_state = 23},
  [118] = {.lex_state = 23},
  [119] = {.lex_state = 3},
  [120] = {.lex_state = 23},
  [121] = {.lex_state = 23},
  [122] = {.lex_state = 23},
  [123] = {.lex_state = 23},
  [124] = {.lex_state = 23},
  [125] = {.lex_state = 23},
  [126] = {.lex_state = 23},
  [127] = {.lex_state = 23},
  [128] = {.lex_state = 23},
  [129] = {.lex_state = 23},
  [130] = {.lex_state = 23},
  [131] = {.lex_state = 23},
  [132] = {.lex_state = 23},
  [133] = {.lex_state = 23},
  [134] = {.lex_state = 23},
  [135] = {.lex_state = 23},
  [136] = {.lex_state = 23},
  [137] = {.lex_state = 23},
  [138] = {.lex_state = 23},
  [139] = {.lex_state = 23},
  [140] = {.lex_state = 23},
  [141] = {.lex_state = 23},
  [142] = {.lex_state = 23},
  [143] = {.lex_state = 23},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_rule] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_condition] = ACTIONS(1),
    [anon_sym_events] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_options] = ACTIONS(1),
    [anon_sym_outcome] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_all] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_regex] = ACTIONS(1),
    [anon_sym_cidr] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_over] = ACTIONS(1),
    [anon_sym_before] = ACTIONS(1),
    [anon_sym_after] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [sym__interpreted_string_literal_basic_content] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [anon_sym_m] = ACTIONS(1),
    [anon_sym_h] = ACTIONS(1),
    [anon_sym_d] = ACTIONS(1),
    [sym_regex_literal] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_nocase] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__whitespace] = ACTIONS(3),
    [sym_not_operator] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(137),
    [sym_rule_definition] = STATE(93),
    [aux_sym_source_file_repeat1] = STATE(93),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_rule] = ACTIONS(7),
    [sym_comment] = ACTIONS(9),
    [sym__whitespace] = ACTIONS(9),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(11), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_RBRACE,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    STATE(5), 1,
      sym_variable_identifier,
    STATE(55), 1,
      sym_match_expression,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(23), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(27), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(6), 5,
      aux_sym__statements,
      sym_assignment_statement,
      sym_declaration_statement,
      sym_expression_statement,
      sym_match_statement,
    ACTIONS(15), 6,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
    STATE(20), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [69] = 15,
    ACTIONS(29), 1,
      sym_identifier,
    ACTIONS(32), 1,
      anon_sym_RBRACE,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(42), 1,
      anon_sym_DOLLAR,
    ACTIONS(48), 1,
      anon_sym_DQUOTE,
    STATE(5), 1,
      sym_variable_identifier,
    STATE(55), 1,
      sym_match_expression,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(45), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(36), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(51), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(3), 5,
      aux_sym__statements,
      sym_assignment_statement,
      sym_declaration_statement,
      sym_expression_statement,
      sym_match_statement,
    ACTIONS(34), 6,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
    STATE(20), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [138] = 4,
    ACTIONS(58), 1,
      sym_attribute_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(56), 15,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(54), 20,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_over,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [185] = 12,
    ACTIONS(66), 1,
      anon_sym_EQ,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(75), 1,
      anon_sym_in,
    ACTIONS(77), 1,
      anon_sym_COMMA,
    ACTIONS(79), 1,
      anon_sym_over,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    STATE(49), 1,
      aux_sym_match_expression_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(73), 5,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(63), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(71), 6,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(60), 12,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [248] = 15,
    ACTIONS(11), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_RBRACE,
    STATE(5), 1,
      sym_variable_identifier,
    STATE(55), 1,
      sym_match_expression,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(23), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(27), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(3), 5,
      aux_sym__statements,
      sym_assignment_statement,
      sym_declaration_statement,
      sym_expression_statement,
      sym_match_statement,
    ACTIONS(85), 6,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
    STATE(20), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [317] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(89), 15,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(87), 20,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_over,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [361] = 8,
    ACTIONS(75), 1,
      anon_sym_in,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(97), 1,
      anon_sym_not,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(73), 5,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(94), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(71), 7,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(91), 12,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [413] = 6,
    ACTIONS(75), 1,
      anon_sym_in,
    ACTIONS(81), 1,
      anon_sym_LBRACK,
    ACTIONS(97), 1,
      anon_sym_not,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(71), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(73), 17,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [461] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(101), 14,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(99), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [502] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(105), 14,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(103), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [543] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(109), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(107), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [583] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(113), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(111), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [623] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(117), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(115), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [663] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(121), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(119), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [703] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(125), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(123), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [743] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(129), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(127), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [783] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(133), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(131), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [823] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(137), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(135), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [863] = 11,
    ACTIONS(143), 1,
      anon_sym_EQ,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(147), 1,
      anon_sym_SLASH,
    ACTIONS(155), 1,
      anon_sym_and,
    ACTIONS(157), 1,
      anon_sym_or,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(153), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 3,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(141), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(139), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [919] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(161), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(159), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [959] = 6,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(147), 1,
      anon_sym_SLASH,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(117), 10,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(115), 17,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1005] = 10,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(147), 1,
      anon_sym_SLASH,
    ACTIONS(155), 1,
      anon_sym_and,
    ACTIONS(157), 1,
      anon_sym_or,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(153), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(165), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(163), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1059] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(169), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(167), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1099] = 9,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(147), 1,
      anon_sym_SLASH,
    ACTIONS(155), 1,
      anon_sym_and,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(153), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(117), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(115), 14,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1151] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(173), 13,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(171), 18,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1191] = 8,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(147), 1,
      anon_sym_SLASH,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(153), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(151), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(117), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(115), 15,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1241] = 5,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(147), 1,
      anon_sym_SLASH,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(117), 12,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(115), 17,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [1285] = 12,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(181), 1,
      anon_sym_RPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(185), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(189), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(65), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1336] = 12,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    ACTIONS(191), 1,
      anon_sym_RPAREN,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(193), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(195), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(64), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1387] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(197), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(199), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(67), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1435] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(201), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(203), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(76), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1483] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(205), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(207), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(24), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1531] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(209), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(211), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(73), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1579] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(8), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(213), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(215), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(22), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1627] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(217), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(219), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(14), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1675] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(221), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(223), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(28), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1723] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(213), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(215), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(22), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1771] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(225), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(227), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(27), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1819] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(229), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(231), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(25), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1867] = 11,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_identifier,
    STATE(9), 1,
      sym_variable_identifier,
    STATE(112), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(233), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(17), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(235), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(23), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1915] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(237), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(239), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(70), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [1963] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(241), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(243), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(74), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [2011] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(245), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(247), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(72), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [2059] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(249), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(251), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(85), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [2107] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(253), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(255), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(77), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [2155] = 11,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(179), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_DOLLAR,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    STATE(63), 1,
      sym_variable_identifier,
    STATE(113), 1,
      sym_function_expression,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(257), 2,
      sym_raw_string_literal,
      sym_regex_literal,
    ACTIONS(177), 3,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
    ACTIONS(259), 3,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
    STATE(84), 9,
      sym__expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_call_expression,
      sym_reference_list_expression,
      sym_index_expression,
      sym_parenthesized_expression,
      sym__string_literal,
      sym_interpreted_string_literal,
  [2203] = 5,
    ACTIONS(265), 1,
      anon_sym_COMMA,
    STATE(48), 1,
      aux_sym_match_expression_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(263), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(261), 14,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_over,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2238] = 6,
    ACTIONS(77), 1,
      anon_sym_COMMA,
    ACTIONS(272), 1,
      anon_sym_over,
    STATE(48), 1,
      aux_sym_match_expression_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(270), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(268), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2275] = 4,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(278), 2,
      anon_sym_before,
      anon_sym_after,
    ACTIONS(276), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(274), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2307] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(282), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(280), 15,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_before,
      anon_sym_after,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2337] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(263), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(261), 14,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      anon_sym_over,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2367] = 4,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(288), 2,
      anon_sym_before,
      anon_sym_after,
    ACTIONS(286), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(284), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2399] = 4,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(294), 2,
      anon_sym_before,
      anon_sym_after,
    ACTIONS(292), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(290), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2431] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(298), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(296), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2459] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(302), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(300), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2487] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(306), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(304), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2515] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(310), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(308), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2543] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(314), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(312), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2571] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(286), 6,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_regex_literal,
    ACTIONS(284), 13,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
      anon_sym_all,
      anon_sym_any,
      anon_sym_not,
      sym_integer_literal,
      sym_float_literal,
      sym_null,
      sym_identifier,
  [2599] = 4,
    ACTIONS(316), 1,
      sym_attribute_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(54), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(56), 14,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [2628] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(87), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(89), 14,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [2654] = 6,
    ACTIONS(318), 1,
      anon_sym_not,
    ACTIONS(320), 1,
      anon_sym_in,
    ACTIONS(322), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(73), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(71), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2686] = 11,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(334), 1,
      anon_sym_and,
    ACTIONS(336), 1,
      anon_sym_or,
    ACTIONS(338), 1,
      anon_sym_COMMA,
    ACTIONS(340), 1,
      anon_sym_RPAREN,
    STATE(102), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [2726] = 11,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(334), 1,
      anon_sym_and,
    ACTIONS(336), 1,
      anon_sym_or,
    ACTIONS(338), 1,
      anon_sym_COMMA,
    ACTIONS(342), 1,
      anon_sym_RPAREN,
    STATE(99), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [2766] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(123), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(125), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2789] = 7,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(117), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [2820] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(127), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(129), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2843] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(99), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(101), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2866] = 6,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(115), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(117), 8,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2895] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(103), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(105), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2918] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(115), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(117), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2941] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(167), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(169), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2964] = 5,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(115), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(117), 10,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [2991] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(171), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(173), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3014] = 8,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(334), 1,
      anon_sym_and,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(117), 3,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [3047] = 9,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(334), 1,
      anon_sym_and,
    ACTIONS(336), 1,
      anon_sym_or,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(344), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [3082] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(161), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3105] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(135), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(137), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3128] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(131), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(133), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3151] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(111), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(113), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3174] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(107), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(109), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3197] = 3,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(119), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(121), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [3220] = 9,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(334), 1,
      anon_sym_and,
    ACTIONS(336), 1,
      anon_sym_or,
    ACTIONS(346), 1,
      anon_sym_RPAREN,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [3254] = 9,
    ACTIONS(326), 1,
      anon_sym_STAR,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(334), 1,
      anon_sym_and,
    ACTIONS(336), 1,
      anon_sym_or,
    ACTIONS(348), 1,
      anon_sym_RPAREN,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(332), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(324), 4,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [3288] = 5,
    ACTIONS(350), 1,
      anon_sym_RBRACE,
    STATE(128), 1,
      sym_section_key,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    STATE(86), 2,
      sym_section,
      aux_sym_rule_definition_repeat1,
    ACTIONS(352), 6,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
  [3311] = 5,
    ACTIONS(355), 1,
      anon_sym_RBRACE,
    STATE(128), 1,
      sym_section_key,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    STATE(88), 2,
      sym_section,
      aux_sym_rule_definition_repeat1,
    ACTIONS(357), 6,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
  [3334] = 5,
    ACTIONS(359), 1,
      anon_sym_RBRACE,
    STATE(128), 1,
      sym_section_key,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    STATE(86), 2,
      sym_section,
      aux_sym_rule_definition_repeat1,
    ACTIONS(357), 6,
      anon_sym_condition,
      anon_sym_events,
      anon_sym_match,
      anon_sym_meta,
      anon_sym_options,
      anon_sym_outcome,
  [3357] = 5,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      sym_raw_string_literal,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(363), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(59), 3,
      sym__string_literal,
      sym_interpreted_string_literal,
      sym_boolean_literal,
  [3377] = 4,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(365), 2,
      sym_raw_string_literal,
      sym_integer_literal,
    STATE(122), 2,
      sym__string_literal,
      sym_interpreted_string_literal,
  [3393] = 4,
    ACTIONS(25), 1,
      anon_sym_DQUOTE,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(367), 2,
      sym_raw_string_literal,
      sym_integer_literal,
    STATE(130), 2,
      sym__string_literal,
      sym_interpreted_string_literal,
  [3409] = 4,
    ACTIONS(369), 1,
      anon_sym_DQUOTE2,
    STATE(96), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(371), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [3424] = 4,
    ACTIONS(7), 1,
      anon_sym_rule,
    ACTIONS(373), 1,
      ts_builtin_sym_end,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    STATE(98), 2,
      sym_rule_definition,
      aux_sym_source_file_repeat1,
  [3439] = 4,
    ACTIONS(375), 1,
      anon_sym_DQUOTE2,
    STATE(96), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(371), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [3454] = 4,
    ACTIONS(377), 1,
      anon_sym_DQUOTE2,
    STATE(94), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(379), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [3469] = 4,
    ACTIONS(381), 1,
      anon_sym_DQUOTE2,
    STATE(96), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(383), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [3484] = 4,
    ACTIONS(386), 1,
      anon_sym_DQUOTE2,
    STATE(92), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(388), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [3499] = 4,
    ACTIONS(390), 1,
      ts_builtin_sym_end,
    ACTIONS(392), 1,
      anon_sym_rule,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    STATE(98), 2,
      sym_rule_definition,
      aux_sym_source_file_repeat1,
  [3514] = 4,
    ACTIONS(338), 1,
      anon_sym_COMMA,
    ACTIONS(395), 1,
      anon_sym_RPAREN,
    STATE(101), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3528] = 2,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(397), 3,
      anon_sym_m,
      anon_sym_h,
      anon_sym_d,
  [3538] = 4,
    ACTIONS(344), 1,
      anon_sym_RPAREN,
    ACTIONS(399), 1,
      anon_sym_COMMA,
    STATE(101), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3552] = 4,
    ACTIONS(338), 1,
      anon_sym_COMMA,
    ACTIONS(402), 1,
      anon_sym_RPAREN,
    STATE(101), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3566] = 3,
    ACTIONS(406), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(404), 2,
      anon_sym_regex,
      anon_sym_cidr,
  [3578] = 3,
    ACTIONS(410), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(408), 2,
      anon_sym_regex,
      anon_sym_cidr,
  [3590] = 3,
    ACTIONS(414), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(412), 2,
      anon_sym_regex,
      anon_sym_cidr,
  [3602] = 4,
    ACTIONS(416), 1,
      anon_sym_EQ,
    ACTIONS(418), 1,
      anon_sym_LPAREN,
    ACTIONS(420), 1,
      anon_sym_DOT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3616] = 3,
    ACTIONS(424), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(422), 2,
      anon_sym_regex,
      anon_sym_cidr,
  [3628] = 2,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(426), 2,
      ts_builtin_sym_end,
      anon_sym_rule,
  [3637] = 3,
    ACTIONS(428), 1,
      sym_integer_literal,
    STATE(53), 1,
      sym_duration_literal,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3648] = 3,
    ACTIONS(428), 1,
      sym_integer_literal,
    STATE(54), 1,
      sym_duration_literal,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3659] = 3,
    ACTIONS(418), 1,
      anon_sym_LPAREN,
    ACTIONS(420), 1,
      anon_sym_DOT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3670] = 3,
    ACTIONS(430), 1,
      anon_sym_LPAREN,
    STATE(17), 1,
      sym_argument_list,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3681] = 3,
    ACTIONS(432), 1,
      anon_sym_LPAREN,
    STATE(68), 1,
      sym_argument_list,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3692] = 3,
    ACTIONS(434), 1,
      anon_sym_in,
    ACTIONS(436), 1,
      anon_sym_over,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3703] = 3,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    STATE(52), 1,
      sym_variable_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3714] = 3,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    STATE(56), 1,
      sym_variable_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3725] = 2,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_rule,
  [3734] = 3,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    STATE(57), 1,
      sym_variable_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3745] = 3,
    ACTIONS(428), 1,
      sym_integer_literal,
    STATE(50), 1,
      sym_duration_literal,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3756] = 3,
    ACTIONS(21), 1,
      anon_sym_DOLLAR,
    STATE(60), 1,
      sym_variable_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3767] = 2,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3775] = 2,
    ACTIONS(442), 1,
      anon_sym_RBRACK,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3783] = 2,
    ACTIONS(444), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3791] = 2,
    ACTIONS(446), 1,
      anon_sym_LBRACE,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3799] = 2,
    ACTIONS(448), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3807] = 2,
    ACTIONS(450), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3815] = 2,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3823] = 2,
    ACTIONS(454), 1,
      anon_sym_COLON,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3831] = 2,
    ACTIONS(456), 1,
      anon_sym_COLON,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3839] = 2,
    ACTIONS(458), 1,
      anon_sym_RBRACK,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3847] = 2,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3855] = 2,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3863] = 2,
    ACTIONS(464), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3871] = 2,
    ACTIONS(466), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3879] = 2,
    ACTIONS(468), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3887] = 2,
    ACTIONS(470), 1,
      sym_identifier,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3895] = 2,
    ACTIONS(472), 1,
      ts_builtin_sym_end,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3903] = 2,
    ACTIONS(414), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3911] = 2,
    ACTIONS(434), 1,
      anon_sym_in,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3919] = 2,
    ACTIONS(474), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3927] = 2,
    ACTIONS(424), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3935] = 2,
    ACTIONS(476), 1,
      anon_sym_PERCENT,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
  [3943] = 2,
    ACTIONS(478), 1,
      anon_sym_in,
    ACTIONS(9), 2,
      sym_comment,
      sym__whitespace,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 69,
  [SMALL_STATE(4)] = 138,
  [SMALL_STATE(5)] = 185,
  [SMALL_STATE(6)] = 248,
  [SMALL_STATE(7)] = 317,
  [SMALL_STATE(8)] = 361,
  [SMALL_STATE(9)] = 413,
  [SMALL_STATE(10)] = 461,
  [SMALL_STATE(11)] = 502,
  [SMALL_STATE(12)] = 543,
  [SMALL_STATE(13)] = 583,
  [SMALL_STATE(14)] = 623,
  [SMALL_STATE(15)] = 663,
  [SMALL_STATE(16)] = 703,
  [SMALL_STATE(17)] = 743,
  [SMALL_STATE(18)] = 783,
  [SMALL_STATE(19)] = 823,
  [SMALL_STATE(20)] = 863,
  [SMALL_STATE(21)] = 919,
  [SMALL_STATE(22)] = 959,
  [SMALL_STATE(23)] = 1005,
  [SMALL_STATE(24)] = 1059,
  [SMALL_STATE(25)] = 1099,
  [SMALL_STATE(26)] = 1151,
  [SMALL_STATE(27)] = 1191,
  [SMALL_STATE(28)] = 1241,
  [SMALL_STATE(29)] = 1285,
  [SMALL_STATE(30)] = 1336,
  [SMALL_STATE(31)] = 1387,
  [SMALL_STATE(32)] = 1435,
  [SMALL_STATE(33)] = 1483,
  [SMALL_STATE(34)] = 1531,
  [SMALL_STATE(35)] = 1579,
  [SMALL_STATE(36)] = 1627,
  [SMALL_STATE(37)] = 1675,
  [SMALL_STATE(38)] = 1723,
  [SMALL_STATE(39)] = 1771,
  [SMALL_STATE(40)] = 1819,
  [SMALL_STATE(41)] = 1867,
  [SMALL_STATE(42)] = 1915,
  [SMALL_STATE(43)] = 1963,
  [SMALL_STATE(44)] = 2011,
  [SMALL_STATE(45)] = 2059,
  [SMALL_STATE(46)] = 2107,
  [SMALL_STATE(47)] = 2155,
  [SMALL_STATE(48)] = 2203,
  [SMALL_STATE(49)] = 2238,
  [SMALL_STATE(50)] = 2275,
  [SMALL_STATE(51)] = 2307,
  [SMALL_STATE(52)] = 2337,
  [SMALL_STATE(53)] = 2367,
  [SMALL_STATE(54)] = 2399,
  [SMALL_STATE(55)] = 2431,
  [SMALL_STATE(56)] = 2459,
  [SMALL_STATE(57)] = 2487,
  [SMALL_STATE(58)] = 2515,
  [SMALL_STATE(59)] = 2543,
  [SMALL_STATE(60)] = 2571,
  [SMALL_STATE(61)] = 2599,
  [SMALL_STATE(62)] = 2628,
  [SMALL_STATE(63)] = 2654,
  [SMALL_STATE(64)] = 2686,
  [SMALL_STATE(65)] = 2726,
  [SMALL_STATE(66)] = 2766,
  [SMALL_STATE(67)] = 2789,
  [SMALL_STATE(68)] = 2820,
  [SMALL_STATE(69)] = 2843,
  [SMALL_STATE(70)] = 2866,
  [SMALL_STATE(71)] = 2895,
  [SMALL_STATE(72)] = 2918,
  [SMALL_STATE(73)] = 2941,
  [SMALL_STATE(74)] = 2964,
  [SMALL_STATE(75)] = 2991,
  [SMALL_STATE(76)] = 3014,
  [SMALL_STATE(77)] = 3047,
  [SMALL_STATE(78)] = 3082,
  [SMALL_STATE(79)] = 3105,
  [SMALL_STATE(80)] = 3128,
  [SMALL_STATE(81)] = 3151,
  [SMALL_STATE(82)] = 3174,
  [SMALL_STATE(83)] = 3197,
  [SMALL_STATE(84)] = 3220,
  [SMALL_STATE(85)] = 3254,
  [SMALL_STATE(86)] = 3288,
  [SMALL_STATE(87)] = 3311,
  [SMALL_STATE(88)] = 3334,
  [SMALL_STATE(89)] = 3357,
  [SMALL_STATE(90)] = 3377,
  [SMALL_STATE(91)] = 3393,
  [SMALL_STATE(92)] = 3409,
  [SMALL_STATE(93)] = 3424,
  [SMALL_STATE(94)] = 3439,
  [SMALL_STATE(95)] = 3454,
  [SMALL_STATE(96)] = 3469,
  [SMALL_STATE(97)] = 3484,
  [SMALL_STATE(98)] = 3499,
  [SMALL_STATE(99)] = 3514,
  [SMALL_STATE(100)] = 3528,
  [SMALL_STATE(101)] = 3538,
  [SMALL_STATE(102)] = 3552,
  [SMALL_STATE(103)] = 3566,
  [SMALL_STATE(104)] = 3578,
  [SMALL_STATE(105)] = 3590,
  [SMALL_STATE(106)] = 3602,
  [SMALL_STATE(107)] = 3616,
  [SMALL_STATE(108)] = 3628,
  [SMALL_STATE(109)] = 3637,
  [SMALL_STATE(110)] = 3648,
  [SMALL_STATE(111)] = 3659,
  [SMALL_STATE(112)] = 3670,
  [SMALL_STATE(113)] = 3681,
  [SMALL_STATE(114)] = 3692,
  [SMALL_STATE(115)] = 3703,
  [SMALL_STATE(116)] = 3714,
  [SMALL_STATE(117)] = 3725,
  [SMALL_STATE(118)] = 3734,
  [SMALL_STATE(119)] = 3745,
  [SMALL_STATE(120)] = 3756,
  [SMALL_STATE(121)] = 3767,
  [SMALL_STATE(122)] = 3775,
  [SMALL_STATE(123)] = 3783,
  [SMALL_STATE(124)] = 3791,
  [SMALL_STATE(125)] = 3799,
  [SMALL_STATE(126)] = 3807,
  [SMALL_STATE(127)] = 3815,
  [SMALL_STATE(128)] = 3823,
  [SMALL_STATE(129)] = 3831,
  [SMALL_STATE(130)] = 3839,
  [SMALL_STATE(131)] = 3847,
  [SMALL_STATE(132)] = 3855,
  [SMALL_STATE(133)] = 3863,
  [SMALL_STATE(134)] = 3871,
  [SMALL_STATE(135)] = 3879,
  [SMALL_STATE(136)] = 3887,
  [SMALL_STATE(137)] = 3895,
  [SMALL_STATE(138)] = 3903,
  [SMALL_STATE(139)] = 3911,
  [SMALL_STATE(140)] = 3919,
  [SMALL_STATE(141)] = 3927,
  [SMALL_STATE(142)] = 3935,
  [SMALL_STATE(143)] = 3943,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [13] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 2, 0, 0),
  [15] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 2, 0, 0),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [29] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(106),
  [32] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements, 2, 0, 0),
  [34] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements, 2, 0, 0),
  [36] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(33),
  [39] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(47),
  [42] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(132),
  [45] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(20),
  [48] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(95),
  [51] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements, 2, 0, 0), SHIFT_REPEAT(20),
  [54] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_identifier, 2, 0, 0),
  [56] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_identifier, 2, 0, 0),
  [58] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [60] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(sym_match_expression, 1, 0, 0),
  [63] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(sym_match_expression, 1, 0, 0),
  [66] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(41),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 3, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 3, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_identifier, 3, 0, 5),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_identifier, 3, 0, 5),
  [91] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(sym_assignment_statement, 3, 0, 6),
  [94] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(sym_assignment_statement, 3, 0, 6),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [99] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3, 0, 0),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3, 0, 0),
  [103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2, 0, 0),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_list_expression, 6, 0, 0),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_list_expression, 6, 0, 0),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 8),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 8),
  [119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_list_expression, 5, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_list_expression, 5, 0, 0),
  [123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 4),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 4),
  [131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 9),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 9),
  [135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_list_expression, 4, 0, 0),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_list_expression, 4, 0, 0),
  [139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, 0, 6),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 6),
  [167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 3),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 3),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_expression_repeat1, 2, 0, 0),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_expression_repeat1, 2, 0, 0),
  [265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(115),
  [268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 2, 0, 0),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 2, 0, 0),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, 0, 0),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, 0, 0),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_duration_literal, 2, 0, 0),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_duration_literal, 2, 0, 0),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 5, 0, 0),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 5, 0, 0),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 4, 0, 0),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 4, 0, 0),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 1, 0, 0),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 1, 0, 0),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 7, 0, 0),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 7, 0, 0),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6, 0, 0),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6, 0, 0),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_statement, 3, 0, 6),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_statement, 3, 0, 6),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_definition_repeat1, 2, 0, 0),
  [352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(96),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(133),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(46),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 1, 0, 2),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_definition, 4, 0, 1),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_definition, 5, 0, 1),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section_key, 1, 0, 0),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [472] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3, 0, 7),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_yaral(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
